package steps

// |@@| F

import (
	"context"
	"gardening/src/dat/maes"
	"gardening/src/lib/maestro"
	"gardening/src/srv/fetchers"
)

type SetupBreadcrumbStep struct {
	Maestro           *maestro.Maestro
	PlantationFetcher *fetchers.PlantationFetcher
}

func (this *SetupBreadcrumbStep) Act(ctx context.Context, in *maes.ShowPlantationMaeIn, out *maes.ShowPlantationMaeOut) (bool, error) {
	o1, _, err := this.PlantationFetcher.FindOneById(ctx, out.In.Request.Id, this.PlantationFetcher.Mod())
	if err != nil {
		return false, err
	}
	out.Extra.AddToScope("plantation_id", o1.Id)
	out.Extra.Navigation.Breadcrumb.Items = append(out.Extra.Navigation.Breadcrumb.Items, o1)
	return true, nil
}
